diff --git a/src/EPI_fmt_plug.c b/src/EPI_fmt_plug.c
index 7db90de4b8..ed802fc2ee 100644
--- a/src/EPI_fmt_plug.c
+++ b/src/EPI_fmt_plug.c
@@ -108,6 +108,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
     return 0;
 
   for(n = 2; n < 62 && atoi16u[ARCH_INDEX(ciphertext[n])] != 0x7F; ++n);
+  if (n < 62)
+	  return 0;
   for(n = 65; n < 105 && atoi16u[ARCH_INDEX(ciphertext[n])] != 0x7F; ++n);
 
   return n == len;
diff --git a/src/chap_fmt_plug.c b/src/chap_fmt_plug.c
index 38975bec63..a44986f6aa 100644
--- a/src/chap_fmt_plug.c
+++ b/src/chap_fmt_plug.c
@@ -97,6 +97,7 @@ static void done(void)
 static int valid(char *ciphertext, struct fmt_main *self)
 {
 	char *ctcopy, *keeptr, *p;
+	int len;
 	if (strncmp(ciphertext,  "$chap$", 6) != 0)
 		return 0;
 	ctcopy = strdup(ciphertext);
@@ -108,7 +109,10 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* challenge */
 		goto err;
-	if (hexlenl(p) > 64)
+	len = strlen(p);
+	if (len > 64 || (len&1))
+		goto err;
+	if (hexlenl(p) != len)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* binary */
 		goto err;
diff --git a/src/openssl_enc_fmt_plug.c b/src/openssl_enc_fmt_plug.c
index d0a7d241fc..d0f9fb78a3 100644
--- a/src/openssl_enc_fmt_plug.c
+++ b/src/openssl_enc_fmt_plug.c
@@ -168,13 +168,13 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (!q)
 		return 0;
 	q = q + 1;
-	if (2 * len != q - p - 1 || 2 * len != strspn(p, HEXCHARS_all))
+	if (2 * len != q - p - 1 || 2 * len != strspn(p, HEXCHARS_lc))
 		return 0;
 	p = q; q = strchr(p, '$');	// last-chunks
 	if (!q)
 		return 0;
 	q = q + 1;
-	len = strspn(p, HEXCHARS_all);
+	len = strspn(p, HEXCHARS_lc);
 	if (len != q - p - 1 || len < 2 || (len & 1) || len/2 > sizeof(cur_salt->last_chunks))
 		return 0;
 	p = q; q = strchr(p, '$');	// inlined
